import java.util.*; 
public class Billard extends Kreis
{
    private double richtung;
    private double geschwindigkeit;
    private double bogenmass;
    
        
    /**
   * Erzeuge eine neue Kugel mit dem Mittelpunkt(x,y) und dem Innenkreisradius r 
   * @param x  die x-Koordinate des Kreismittelpunktes
   * @param y  die y-Koordinate des Kreismittelpunktes
   * @param r  der Radius des Kreises
   * @param f  die Farbe
   * @param r  der Richtungswinkel
   * @param g  die Geschwindigkeit
   */
    
 
   public Billard(int x, int y, int r, String f, double alpha, double g)
   {      
       super(x,y,r,f);
       richtung=alpha;
       geschwindigkeit=g;
       zeichnen();
    }
 
     /**
   * Bewege die Kugel ber den Bildschirm.
   */
     public void bewege()
    {  
       loeschen(); 
       bogenmass=Math.PI*richtung/180;
       // Verschiebung um geschwindigkeit Einheiten in die aktuelle Richtung
       verschieben((int)(Math.cos(bogenmass)*geschwindigkeit),(int)(-Math.sin(bogenmass)*geschwindigkeit));
       
       // Abprallen am linken bzw rechten Rand
       if (getXPos()-getRadius()<=0 || getXPos()+getRadius()>=640)
          richtung = 180-richtung;
       // Abprallen am oberen bzw. unteren Rand   
       if (getYPos()-getRadius()<=0 || getYPos()+getRadius()>=480)
          richtung = -richtung;
          
       zeichnen();
    }

    // Diese Methode berprft, ob die Kugel von einer anderen Kugel b getroffen wird.
    public void trifft(Billard b)
    { 
      double hilf;  
      // Wenn der Abstand zwischen den beiden Kugeln hinreichend klein ist, wird die jeweilige Richtung der Kugeln getauscht.
      if (Math.sqrt(Math.pow(getXPos()-b.getXPos(),2)+Math.pow(getYPos()-b.getYPos(),2)) <= getRadius()+b.getRadius())
      {
        hilf = getRichtung();
        setRichtung(b.getRichtung());
        b.setRichtung(hilf);
      }  
    }
    
    public void setRichtung(double r)
    { richtung = r;
    }    
  
        
   /**
   * Liefere die Geschwindigkeit
   */
  
   public double getGeschwindigkeit()
   { return geschwindigkeit;
   }
        
  /**
   * Liefere den Richtungswinkel
   */ 
    public double getRichtung()
    { return richtung;
    }
          
}
