import java.awt.geom.Ellipse2D;

/**
 * Ein Kreis, der manipuliert werden kann und sich selbst auf einer
 * Leinwand zeichnet.
 * 
 * @author  Michael Klling und David J. Barnes erweitert von A. Dietz (07. Mrz 2007)
 * @version 1.0  (3. Januar 2003)
 */

public class Kreis
{
  private int radius;
  private int xPosition;
  private int yPosition;
  private String farbe;
  private Ellipse2D.Double myGraphObject;
  private Leinwand leinwand;
 
  
  /**
   * Erzeuge einen neuen Kreis. Die Startwerte knnen eingegeben werden.
   * @param x  die x-Koordinate des Kreismittelpunktes
   * @param y  die y-Koordinate des Kreismittelpunktes
   * @param r  der Radius des Kreises
   * @param f  die Farbe des Rechteckes
   */
  public Kreis(int x, int y, int r, String f)
  {
    xPosition = x;
    yPosition = y;
    radius = r;
    farbe = f;
    myGraphObject= new Ellipse2D.Double(xPosition-radius, yPosition-radius, 2*radius, 2*radius);
    leinwand = Leinwand.gibLeinwand();
  }
  
  
 

  /**
   * ndere den Radius dieses Kreises in 'neuerRadius'
   * (Angabe in Bildschirmpunkten).
   * 'neuerRadius' muss grer gleich Null sein.
   * @param x  neuerRadius
   */
  public void setzeRadius(int neuerRadius)
  {
    if (radius >=0)
      radius = neuerRadius;
    else 
      System.out.println("Ungltige Eingabe!");
   }

  
  /**
   * Verschiebe die Position des Kreises 
   * (Angabe der Verschiebung in x- und y-Richtung).
   * @param dx  Verschiebung in x-Richtung
   * @param dy  Verschiebung in y-Richtung
   */
  public void verschieben(int neuesX, int neuesY)
  {
    xPosition = xPosition+neuesX;
    yPosition = yPosition+neuesY;
   }
  
  
  /**
   * ndere die Position des Kreises 
   * (Angabe der Koordinaten des Mittelpunktes).
   * 'neuesX' und 'neuesY' mssen grer gleich Null sein.
   * @param neuesX  neue x-Position des Mittelpunktes
   * @param neuesY neue y-Position des Mittelpunktes
   */
  public void setzeMPos(int neuesX, int neuesY)
  {
    xPosition = neuesX;
    yPosition = neuesY;
  }
  
  
  /**
   * ndere die Farbe dieses Kreises in 'neueFarbe'.
   * Gltige Angaben sind "rot", "gelb", "blau", "gruen", "grau",
   * "lila" und "schwarz".
   * @param neueFarbe neueFarbe
   */
  public void setzeFarbe(String neueFarbe)
  {
    farbe = neueFarbe;
    
  }

  /**
   * Zeichne diesen Kreis mit seinen aktuellen Werten auf den Bildschirm.
   */
  public void zeichnen()
  {
      myGraphObject.setFrame(xPosition-radius, yPosition-radius, 2*radius, 2*radius);
      leinwand.zeichne(farbe,myGraphObject);
  }

  /**
   * Lsche diesen Kreis vom Bildschirm.
   */
  public void loeschen()
  {
   leinwand.entferne(myGraphObject);
  }
  
  /** Rckgabe der x-Position des Kreismittelpunktes
  * @return xPosition x-Position des Kreismittelpunktes
  */ 
  public int getXPos()
  { return xPosition;}
  
  /** Rckgabe der y-Position des Kreismittelpunktes
  * @return yPosition y-Position des Kreismittelpunktes
  */
   public int getYPos()
  { return yPosition;}
  
  /** Rckgabe des Radius
  * @return radius Radius des Kreises
  */
  public int getRadius()
  { return radius;}
}
